/**
 * Copyright (c) 2001/2003 Distributed Systems Research Group.
 * All rights reserved.
 *
 * For more information on Distributed Systems Research Group (DSRG),
 * please see <http://www.ics.agh.edu.pl/>.
 *
 * @author radzisz
 * file name: FortuneClient.java
 *
 */
package edu.agh.sius;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import edu.agh.sius.ejb.FortuneTellerSB;
import edu.agh.sius.ejb.FortuneTellerSBHome;
import edu.agh.sius.ejb.FortuneTellerSBUtil;


public class FortuneClient {

	public static void main(String[] args) {

		System.out.println(new FortuneClient().getFortune());
	}

	public String getFortune() {

		try {
			FortuneTellerSBHome home = FortuneTellerSBUtil.getHome();
			FortuneTellerSB fortuneTeller = home.create();
			return fortuneTeller.getFortune();
		} catch (NamingException e) {
			e.printStackTrace();
		} catch (CreateException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		return "Could not get fortune";
	}
}
