package edu.agh.sius.ejb;

import javax.ejb.CreateException;
import org.apache.log4j.Logger;
import javax.ejb.SessionBean;


import java.util.Collection;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.FinderException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.InitialContext;
import javax.naming.NamingException;


/**
 * Fortune Session Bean
 *
 * @ejb:bean name="FortuneTellerSB"
 *	     display-name="Fortune Teller Session Bean"
 *	     type="Stateless"
 *	     transaction-type="Container"
 *	     jndi-name="ejb/fortune/FortuneTellerSB"
 *
 *
 **/

public class FortuneTellerEJB extends AbstractSBBean implements SessionBean {

	private static Logger logger = Logger.getLogger("edu.agh.sius.fortune");
	private FortuneEBLocalHome fortuneEBLocalHome;

	/**
	* Create the Session Bean
	* @throws CreateException
	* @ejb:create-method view-type="remote"
	**/
	public void ejbCreate() throws CreateException {
		try {
			fortuneEBLocalHome = FortuneEBUtil.getLocalHome();
			logger.info("get fortune localHome reference");

		} catch (NamingException e) {
			logger.error("naming exception", e);
			throw new CreateException(
				"could not get reference to entity bean" + e);
		}
	}

	/**
	 * Method returns a fortune
	 * @return a fortune as a String
	 * @ejb:interface-method view-type="remote"
	 **/
	public String getFortune() {
			logger.info("getFortuneCalled");
			Collection fortunes;
			try {
				fortunes = fortuneEBLocalHome.findAll();
				if (fortunes.size() > 0) {
					int which = (int) (Math.random() * fortunes.size());
					FortuneEBLocal fortune =
						(FortuneEBLocal) fortunes.toArray(
					new FortuneEBLocal[0])[which];
					logger.info("got fortune - " + fortune.getText());
					return fortune.getText();
				} else
					logger.info("no fortunes in db - dummyFortune");
			} catch (FinderException e) {
				logger.error("could not find fortune", e);
			}
			return "dummyFortune";
	}

}
